/*
 * ̃\[XR[h blanco FrameworkɂĎĂ܂B
 */
package blanco.encryption.task;

import blanco.encryption.task.valueobject.BlancoEncryptionDesedeBatchProcessInput;

/**
 * ob`NX [BlancoEncryptionDesedeBatchProcess]̒ېeNXB
 *
 * ̃NXp [blanco.encryption.task]pbP[W[BlancoEncryptionDesedeBatchProcess]NX쐬Ďۂ̃ob`ĂB
 */
abstract class AbstractBlancoEncryptionDesedeBatchProcess {
    /**
     * IB
     */
    public static final int END_SUCCESS = 0;

    /**
     * ُ͈IBIjava.lang.IllegalArgumentExceptionꍇB
     */
    public static final int END_ILLEGAL_ARGUMENT = 8;

    /**
     * ُIBob`̏JnɎsꍇAѓIjava.lang.Error܂java.lang.RuntimeExceptionꍇB
     */
    public static final int END_ERROR = 9;

    /**
     * R}hCsꂽۂ̃Gg|CgłB
     *
     * @param args R\[pꂽB
     */
    public static final void main(final String[] args) {
        // ̉ӏŃRpCG[ꍇAAbstractBlancoEncryptionDesedeBatchProcessNXp blanco.encryption.taskpbP[W BlancoEncryptionDesedeBatchProcessNX쐬邱Ƃɂłꍇ܂B
        final AbstractBlancoEncryptionDesedeBatchProcess batchProcess = new BlancoEncryptionDesedeBatchProcess();

        // ob`̈B
        final BlancoEncryptionDesedeBatchProcessInput input = new BlancoEncryptionDesedeBatchProcessInput();

        boolean isNeedUsage = false;

        // R}hC̉͂Ȃ܂B
        for (int index = 0; index < args.length; index++) {
            String arg = args[index];
            if (arg.startsWith("-verbose=")) {
                input.setVerbose(arg.substring(9));
            } else if (arg.startsWith("-inputDir=")) {
                input.setInputDir(arg.substring(10));
            } else if (arg.startsWith("-outputDir=")) {
                input.setOutputDir(arg.substring(11));
            } else if (arg.startsWith("-password=")) {
                input.setPassword(arg.substring(10));
            } else if (arg.equals("-?") || arg.equals("-help")) {
                usage();
                System.exit(END_SUCCESS);
            } else {
                System.out.println("BlancoEncryptionDesedeBatchProcess: ̓p[^[" + arg + "]͖܂B");
                isNeedUsage = true;
            }
        }

        if (isNeedUsage) {
            usage();
        }

        int retCode = batchProcess.execute(input);

        // IR[h߂܂B
        // ӁFSystem.exit()ĂяoĂ_ɒӂĂB
        System.exit(retCode);
    }

    /**
     * ̓Iȃob`eLq邽߂̃\bhłB
     *
     * ̃\bhɎۂ̏eLq܂B
     *
     * @param input ob`̓̓p[^B
     * @return ob`̏IR[hB
     */
    public abstract int process(final BlancoEncryptionDesedeBatchProcessInput input);

    /**
     * NXCX^Xăob`sۂ̃Gg|CgłB
     *
     * @param input ob`̓̓p[^B
     * @return ob`̏IR[hB
     */
    public final int execute(final BlancoEncryptionDesedeBatchProcessInput input) {
        try {
            if (input.getInputDir() == null) {
                System.out.println("BlancoEncryptionDesedeBatchProcess: JnsBK{̓̓p[^[inputDir]ݒ肳Ă܂B");
                System.exit(END_ILLEGAL_ARGUMENT);
            }

            if (input.getOutputDir() == null) {
                System.out.println("BlancoEncryptionDesedeBatchProcess: JnsBK{̓̓p[^[outputDir]ݒ肳Ă܂B");
                System.exit(END_ILLEGAL_ARGUMENT);
            }

            if (input.getPassword() == null) {
                System.out.println("BlancoEncryptionDesedeBatchProcess: JnsBK{̓̓p[^[password]ݒ肳Ă܂B");
                System.exit(END_ILLEGAL_ARGUMENT);
            }

            // ob`̖{̂s܂B
            int retCode = process(input);

            return retCode;
        } catch (IllegalArgumentException ex) {
            System.out.println("BlancoEncryptionDesedeBatchProcess: ͗O܂Bob`𒆒f܂B:" + ex.toString());
            // ُ͈IB
            return END_ILLEGAL_ARGUMENT;
        } catch (RuntimeException ex) {
            System.out.println("BlancoEncryptionDesedeBatchProcess: ^CO܂Bob`𒆒f܂B:" + ex.toString());
            ex.printStackTrace();
            // ُIB
            return END_ERROR;
        } catch (Error er) {
            System.out.println("BlancoEncryptionDesedeBatchProcess: ^CG[܂Bob`𒆒f܂B:" + er.toString());
            er.printStackTrace();
            // ُIB
            return END_ERROR;
        }
    }

    /**
     * ̃ob`NX̎g̐Wo͂Ɏ߂̃\bhłB
     */
    public static final void usage() {
        System.out.println("BlancoEncryptionDesedeBatchProcess: Usage:");
        System.out.println("  java blanco.encryption.task.BlancoEncryptionDesedeBatchProcess -verbose=l1 -inputDir=l2 -outputDir=l3 -password=l4");
        System.out.println("    -verbose");
        System.out.println("      [verbose[hœ삳邩ǂB]");
        System.out.println("    -inputDir");
        System.out.println("      [̓fBNgw肵܂B]");
        System.out.println("      K{p[^B");
        System.out.println("    -outputDir");
        System.out.println("      [o̓fBNgw肵܂B]");
        System.out.println("      K{p[^B");
        System.out.println("    -password");
        System.out.println("      [pX[hw肵܂B]");
        System.out.println("      K{p[^B");
        System.out.println("    -? , -help");
        System.out.println("      [g\܂B]");
    }
}
