package blanco.encryption.task;

import java.io.File;
import java.io.IOException;

import blanco.encryption.BlancoEncryptionConstants;
import blanco.encryption.BlancoEncryptionDesede;
import blanco.encryption.task.valueobject.BlancoEncryptionDesedeBatchProcessInput;

/**
 * ob`NXB
 */
public class BlancoEncryptionDesedeBatchProcess extends
        AbstractBlancoEncryptionDesedeBatchProcess {
    /**
     * Í̃t@Cɕt^镶B
     */
    private static final String ENCRYPTED_FILE_EXT = ".blancodesede";

    /**
     * ̓Iȃob`eLq邽߂̃\bhłB
     * 
     * ̃\bhɎۂ̏eLq܂B
     * 
     * @param input
     *            ob`̓̓p[^B
     * @return ob`̏IR[hB
     */
    public int process(BlancoEncryptionDesedeBatchProcessInput input) {
        System.out.println("- " + BlancoEncryptionConstants.PRODUCT_NAME + " ("
                + BlancoEncryptionConstants.VERSION + ")");

        try {
            // TODO t@C݃`FbNB
            final File fileInputDir = new File(input.getInputDir());
            if (fileInputDir.exists() == false) {
                System.out.println("w̓̓fBNg[" + input.getInputDir()
                        + "]͌܂Bf܂B");
                return END_ILLEGAL_ARGUMENT;
            }

            final File fileOutputDir = new File(input.getOutputDir());
            if (fileOutputDir.exists() == false) {
                if (fileOutputDir.mkdirs() == false) {
                    throw new IllegalArgumentException("fBNg["
                            + input.getOutputDir() + "]쐬s");
                }
            } else {
                if (fileOutputDir.isFile()) {
                    throw new IllegalArgumentException("fBNg["
                            + input.getOutputDir() + "]͎ۂɂ̓t@CłB");
                }
            }

            if (fileInputDir.getCanonicalPath().equals(
                    fileOutputDir.getCanonicalPath())) {
                throw new IllegalArgumentException("̓fBNg["
                        + input.getInputDir() + "]Əo̓fBNg["
                        + input.getOutputDir()
                        + "]Ƃ͓fBNgłBقȂfBNgw肵ĂB");
            }

            final File[] files = fileInputDir.listFiles();

            for (int index = 0; index < files.length; index++) {
                if (files[index].isFile() == false) {
                    // t@CȊO͏܂B
                    continue;
                }

                // TODO ̃t@Cǂ߂邩ǂ`FbNKvB

                final BlancoEncryptionDesede desede = new BlancoEncryptionDesede();

                if (files[index].getName().endsWith(ENCRYPTED_FILE_EXT) == false) {
                    // Í
                    final File fileOutput = new File(fileOutputDir
                            .getAbsolutePath()
                            + "/" + files[index].getName() + ENCRYPTED_FILE_EXT);
                    System.out.println("blanco.encrypt["
                            + files[index].getAbsolutePath() + "] -> ["
                            + fileOutput.getName() + "]");
                    desede.encrypt(files[index], fileOutput, input
                            .getPassword());
                } else {
                    // 
                    final File fileOutput = new File(fileOutputDir
                            .getAbsolutePath()
                            + "/"
                            + files[index].getName().substring(
                                    0,
                                    files[index].getName().length()
                                            - ENCRYPTED_FILE_EXT.length()));
                    System.out.println("blanco.decrypt["
                            + files[index].getAbsolutePath() + "] -> ["
                            + fileOutput.getName() + "]");
                    desede.decrypt(files[index], fileOutput, input
                            .getPassword());
                }
            }

            return END_SUCCESS;
        } catch (IOException ex) {
            // ex.printStackTrace();
            throw new IllegalArgumentException("o͗O܂:" + ex.toString());
        }
    }
}
